#! /bin/bash
WINEBIN="bisheng-engine-wine8"
PACKAGE_VERSION="3.0.3"

PACKAGE_NAME="printer-driver-bisheng-sharp-mx-m283n-pcl6"
PRINTER_NAME=( "SHARP MX-M283N PCL6" "SHARP MX-M363N PCL6" "SHARP MX-M453N PCL6" "SHARP MX-M503N PCL6" "SHARP MX-M363U PCL6" "SHARP MX-M453U PCL6" "SHARP MX-M503U PCL6" "SHARP MX-B401 PCL6" "SHARP MX-B381 PCL6" "SHARP MX-B380P PCL6" "SHARP MX-B400P PCL6" "SHARP MX-M623N PCL6" "SHARP MX-M623U PCL6" "SHARP MX-M753N PCL6" "SHARP MX-M753U PCL6" "SHARP AR-M452U PCL6" "SHARP MX-B402 PCL6" "SHARP MX-B382 PCL6" "SHARP MX-B402SC PCL6" "SHARP MX-B382SC PCL6" "SHARP MX-M282N PCL6" "SHARP MX-M362N PCL6" "SHARP MX-M452N PCL6" "SHARP MX-M502N PCL6" "SHARP MX-B382P PCL6" "SHARP AR-4528U PCL6" )

CONTAINER_PATH="$HOME/.deepinwine/$PACKAGE_NAME"
OPT_PATH="/opt/deepinwine/printer_drv/$PACKAGE_NAME"
REGDIR="reg"
FILEDIR="files"

PRINTER_C=$1
found=0
for name in "${PRINTER_NAME[@]}"; do
    if [ "$PRINTER_C" = "$name" ]; then
        found=1
        break
    fi
done

if [ $found -eq 0 ]; then
    echo "printer $PRINTER_C not found"
    exit 0
fi

if [ -z "$PACKAGE_NAME" -o ! -d "$OPT_PATH" ]; then
    exit 1
fi

if [ -d "$CONTAINER_PATH" ]; then
    # compare version
    if [ ! -f "$CONTAINER_PATH/VERSION" ] || [ "$(cat "$CONTAINER_PATH/VERSION")" != "$PACKAGE_VERSION" ]; then
        rm -rf "$CONTAINER_PATH"
    fi
fi

WININI="$CONTAINER_PATH/drive_c/windows/win.ini"
if [ -f  $WININI ]; then
    grep -q "^$PRINTER_C=winerp.drv,USB" "$WININI" && exit 0
fi

if [ -d "$OPT_PATH/$REGDIR" ]; then
    find "$OPT_PATH/$REGDIR" -type f -regex ".*\.reg" | while read file; do
        WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "$file"
    done
fi

if [ -d "$OPT_PATH/$FILEDIR" ]; then
    find "$OPT_PATH/$FILEDIR" -not -type d | while read file; do
        path="$CONTAINER_PATH/drive_c/${file#*$FILEDIR/}"
        dir="${path%/*}"
        mkdir -p "$dir"
        cp -d "$file" "$path"
    done
fi

if [ -f "$WININI" ]; then
    grep -q "^\[devices\]" "$WININI" || sed -i -e "$ a [devices]" "$WININI"
    grep -q "^\[PrinterPorts\]" "$WININI" || sed -i -e "$ a [PrinterPorts]" "$WININI"
    sed -i -e "/^\[devices\]/a $PRINTER_C=winerp.drv,USB" "$WININI"
    sed -i -e "/^\[PrinterPorts\]/a $PRINTER_C=winerp.drv,USB,15,45" "$WININI"
fi

WINESERVER_RUNNING=1
WINESERVER_FINDNUM=0
while [ $WINESERVER_RUNNING -eq 1 ]
do
        WINESERVER_PATH=`ps -aux|grep wineserver|grep -v grep`
        if [ "$WINESERVER_PATH" = "" ] || [ $WINESERVER_FINDNUM -eq 3 ]; then
                WINESERVER_RUNNING=0
        else
                let WINESERVER_FINDNUM+=1
                sleep 1
        fi
done

echo "$PACKAGE_VERSION" > "$CONTAINER_PATH/VERSION"
echo "$PRINTER_NAME" > "$CONTAINER_PATH/name.log"

WINEPREFIX="$CONTAINER_PATH" $WINEBIN winecfg -v win7
WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "/opt/deepinwine/printer_drv/printer-driver-bisheng-sharp-mx-m283n-pcl6/winprint.reg"
WINEPREFIX=$CONTAINER_PATH $WINEBIN wineserver -w 
